# coding: utf-8

"""
    Selling Partner API for Pricing

    The Selling Partner API for Pricing helps you programmatically retrieve product pricing and offer information for Amazon Marketplace products.  # noqa: E501

    OpenAPI spec version: v0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class SellerFeedbackType(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'seller_positive_feedback_rating': 'float',
        'feedback_count': 'int'
    }

    attribute_map = {
        'seller_positive_feedback_rating': 'SellerPositiveFeedbackRating',
        'feedback_count': 'FeedbackCount'
    }

    def __init__(self, seller_positive_feedback_rating=None, feedback_count=None):  # noqa: E501
        """SellerFeedbackType - a model defined in Swagger"""  # noqa: E501
        self._seller_positive_feedback_rating = None
        self._feedback_count = None
        self.discriminator = None
        if seller_positive_feedback_rating is not None:
            self.seller_positive_feedback_rating = seller_positive_feedback_rating
        self.feedback_count = feedback_count

    @property
    def seller_positive_feedback_rating(self):
        """Gets the seller_positive_feedback_rating of this SellerFeedbackType.  # noqa: E501

        The percentage of positive feedback for the seller in the past 365 days.  # noqa: E501

        :return: The seller_positive_feedback_rating of this SellerFeedbackType.  # noqa: E501
        :rtype: float
        """
        return self._seller_positive_feedback_rating

    @seller_positive_feedback_rating.setter
    def seller_positive_feedback_rating(self, seller_positive_feedback_rating):
        """Sets the seller_positive_feedback_rating of this SellerFeedbackType.

        The percentage of positive feedback for the seller in the past 365 days.  # noqa: E501

        :param seller_positive_feedback_rating: The seller_positive_feedback_rating of this SellerFeedbackType.  # noqa: E501
        :type: float
        """

        self._seller_positive_feedback_rating = seller_positive_feedback_rating

    @property
    def feedback_count(self):
        """Gets the feedback_count of this SellerFeedbackType.  # noqa: E501

        The number of ratings received about the seller.  # noqa: E501

        :return: The feedback_count of this SellerFeedbackType.  # noqa: E501
        :rtype: int
        """
        return self._feedback_count

    @feedback_count.setter
    def feedback_count(self, feedback_count):
        """Sets the feedback_count of this SellerFeedbackType.

        The number of ratings received about the seller.  # noqa: E501

        :param feedback_count: The feedback_count of this SellerFeedbackType.  # noqa: E501
        :type: int
        """
        if feedback_count is None:
            raise ValueError("Invalid value for `feedback_count`, must not be `None`")  # noqa: E501

        self._feedback_count = feedback_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SellerFeedbackType, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SellerFeedbackType):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
